#!/usr/bin/env python
# -*- encoding: utf-8 -*-
"""
Author renyupeng
coding=utf-8
@Time    : 2023/2/7 下午
@Site    :
@File    : send_feishu_msg.py
@Software: PyCharm
@contact: renyupeng@c-top.com.cn
@Tel 1501435553
encoding=utf-8
"""
import logging
import json
import requests
import traceback


class SendFeiShuMsg:
    @staticmethod
    def send_robot_msg(msg_content):
        try:
            url = 'https://open.feishu.cn/open-apis/bot/v2/hook/6f1e77f2-cdc3-48d6-957e-4c9953da55c0'
            req_head = {"Content-Type": "application/json"}
            req_data = {
                "msg_type": "text",
                "content": {
                    "text": msg_content
                }
            }
            data = json.dumps(req_data)
            logging.info("send_robot_msg req_url:{}, req_data:{}".format(url, data))
            response = requests.post(url=url, data=data, headers=req_head)
            result = response.json()
            logging.info("send_robot_msg response:{}".format(response.json()))
            if result.get("StatusCode") == 0:
                logging.info("飞书通知发送成功")
                return True
            else:
                logging.error("飞书通知发送失败，请检查!")
                return False
        except Exception as e:
            logging.error("send_robot_msg Error:{}".format(traceback.format_exc()))

    @staticmethod
    def send_cookie_robot_msg(msg_content):
        try:
            url = 'https://open.feishu.cn/open-apis/bot/v2/hook/ce075a9a-e224-4435-8028-55ae509b4b32'
            req_head = {"Content-Type": "application/json"}
            req_data = {
                "msg_type": "text",
                "content": {
                    "text": msg_content
                }
            }
            data = json.dumps(req_data)
            print(data)
            logging.info("send_robot_msg req_url:{}, req_data:{}".format(url, data))
            response = requests.post(url=url, data=data, headers=req_head)
            print(response.text)
            result = response.json()
            print(result)
            logging.info("send_robot_msg response:{}".format(response.json()))
            if result.get("StatusCode") == 0:
                logging.info("飞书通知发送成功")
                return True
            else:
                logging.error("飞书通知发送失败，请检查!")
                return False
        except Exception as e:
            logging.error("send_robot_msg Error:{}".format(traceback.format_exc()))


if __name__ == '__main__':
    SendFeiShuMsg.send_robot_msg('11111')
